xfstests: randholes: only allocate write buffer when needed
[xfstests-dev.git] / 003
1 #! /bin/bash
2 # FS QA Test No. 003
3 #
4 # exercise xfs_db bug #784078
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2001 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=nathans@sgi.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 # get standard environment, filters and checks
31 . ./common.rc
32 . ./common.filter
33
34 tmp=/tmp/$$
35 here=`pwd`
36 status=0        # success is the default!
37 trap "rm -f $tmp.*; exit \$status" 0 1 2 3 15
38
39 _need_to_be_root
40
41 # real QA test starts here
42 _supported_fs xfs
43 _supported_os IRIX Linux
44
45 [ -f core ] && rm -f core
46 [ -f core ] && echo "Warning: can't nuke existing core file!"
47
48 test_done()
49 {
50         sts=$?
51         [ -f core ] && echo "FAILED - core file"
52         [ ! -f core -a $sts != 0 ] && echo "FAILED - non-zero exit status"
53         rm -f core
54 }
55
56 # real QA test starts here
57
58 echo "=== TEST 1 ==="
59 xfs_db -r -c 'pop' -c 'type sb' $TEST_DEV
60 test_done
61
62 echo "=== TEST 2 ==="
63 xfs_db -r -c 'push sb' $TEST_DEV
64 test_done
65
66 echo "=== TEST 3 ==="
67 xfs_db -r -c 'pop' -c 'push sb' $TEST_DEV
68 test_done
69
70 echo "=== TEST 4 ==="
71 xfs_db -r -c 'type sb' -c 'print' $TEST_DEV
72 test_done
73
74 echo "=== TEST 5 ==="
75 xfs_db -r -c 'inode 128' -c 'push' -c 'type' $TEST_DEV >$tmp.out 2>&1
76 test_done
77 # On IRIX we lose state after a "push" operation and don't
78 # know the type is still inode
79 # Probably not worth changing xfs_db on IRIX for this.
80 if [ "$HOSTOS" != "IRIX" ]; then
81     if ! grep -q "current type is \"inode\"" $tmp.out
82     then
83             cat $tmp.out
84     fi
85 fi
86
87 echo "=== TEST 6 ==="
88 xfs_db -r -c 'sb' -c 'a' $TEST_DEV >$tmp.out 2>&1 # don't care about output
89 test_done
90
91 echo "=== TEST 7 ==="
92 xfs_db -r -c 'ring' $TEST_DEV
93 test_done